// ## Задание

// Реализовать универсальный фильтр массива объектов. Задача должна быть реализована на языке javascript, без использования фреймворков и сторонник библиотек (типа Jquery).

// #### Технические требования:
// - Написать функцию `filterCollection()`, которая позволит отфильтровать любой массив по заданным ключевым словам.
// - Функция должна принимать на вход три основных аргумента:
//   - массив, который надо отфильтровать
//   - строку с ключевыми словами, которые надо найти внутри массива (одно слово или несколько слов, разделеных пробелом)
//   - boolean флаг, который будет говорить, надо ли найти все ключевые слова (`true`), либо же достаточно совпадения одного из них (`false`)
//   - четвертый и последующие аргументы будут являться именами полей, внутри которых надо искать совпадение. Если поле находится не на первом уровне объекта, к нему надо указать полный путь через `.`. Уровень вложенности полей может быть любой.
// - Пример вызова функции:

// ```javascript
// filterCollection(vehicles, 'en_US Toyota', true, 'name', 'description', 'contentType.name', 'locales.name', 'locales.description')
// ```
//    В данном примере будет отфильтрован массив `vehicles`, с помощью ключевых слов `en_US` и `Toyota`. `true` в третьем параметре означает, что для успешного включения записи в финальный результат должно быть совпадение по обоим ключевым словам. Последние несколько параметров содержат имена полей, внутри которых надо искать ключевые слова. Например `contentType.name` означает, что внутри каждого объекта `vehicle` может быть поле `contentType`, которое является объектом или массивом объектов, внутри которых может быть поле `name`. Именно в этом поле (а также в других указанных) необходимо искать сопадения с ключевыми словами.
// - В примере выше - запись `locales.name` означает, что поле `locales` внутри объекта `vehicle` может быть как объектом, так и массивом. Если оно является массивом, это значит, что внутри массива находятся объекты, у каждого из которых может быть свойство `name`. Для успешной фильтрации достаточно нахождения ключевого слова хотя бы в одном из элементов массива.
// - Разные ключевые слова могут находиться в разных свойствах объекта. Например, в примере выше, ключевое слово `en_US` может быть найдено в поле `locales.name`, в то время как ключевое слово `Toyota` может, например, находиться внутри свойства `description`. При этом такой объект должен быть найден.
// - Поиск должен быть нечувствительным к регистру.

// ##### Примечание:
// Реализацию данной задачи можно использовать в реальной жизни. Например, если на странице есть таблица с данными, а вверху есть строка поиска, данную функцию можно использовать для фильтра значений в таблице при вводе ключевых слов в строку поиска

let users = [
  {
    nameUser: "Victoria",
    id: "10",
    age: "27",
    auto: { brand: "vw", releaseDate: 2015 },
  },
  {
    nameUser: "Leo",
    id: "11",
    age: "27",
    auto: { brand: "vw", releaseDate: 2019 },
  },
  {
    nameUser: "John",
    id: "12",
    age: "32",
    auto: { brand: "mercedes-benz", releaseDate: 2022 },
  },
  {
    nameUser: "Leo",
    id: "13",
    age: "36",
    auto: { brand: "vw", releaseDate: 2005 },
  },
];

function filterCollection(arr, string, flag, ...args) {
  let [...str] = string.split(" ");
  let arrStr = [...str].map((item) => item); // массив строк которые ищем
  let arrArgs = [...args].map((item) => item); // массив имен полей, внутри которых ищем ключевые слова

  let newUsers = arr.filter((item) => {
    for (let key in item) {
      if (typeof item[key] !== "object") {
        for (let itemText of arrStr) {
          for (let itemArrArgs of arrArgs) {
            if (itemArrArgs.includes(".") === false) {
              if (itemArrArgs === key && itemText === item[key]) {
                return item;
              }
            }
          }
        }
      } else {
        for (let itemText of arrStr) {
          for (let itemArrArgs of arrArgs) {
            if (itemArrArgs.includes(".") === true) {
              let arritemArrArgs = itemArrArgs.split(".");
              if (arritemArrArgs[0] === key) {
                for (let key2 in item[key]) {
                  if (key2 === arritemArrArgs[1]) {
                    if (itemText === item[key][key2]) {
                      return item;
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  });
  return newUsers;
}

console.log(
  filterCollection(users, "Leo 120 vw", false, "nameUser", "id", "auto.brand")
);
